inherit_gem:
  gitlab-styles:
    - rubocop-default.yml

inherit_from:
  <% unless ENV['REVEAL_RUBOCOP_TODO'] == '1' %>
  - '.rubocop_todo.yml'
  <% end %>

AllCops:
  # The oldest supported Ruby version.
  TargetRubyVersion: 3.1
  Exclude:
    - 'vendor/**/*'
    - 'tmp/**/*'
    - 'bin/**/*'
  # Use absolute path to avoid orphan directories with changed workspace root.
  CacheRootDirectory: <%= Dir.getwd %>/tmp
  MaxFilesInCache: 1_000_000
  NewCops: enable

CodeReuse/ActiveRecord:
  Enabled: false

Gemspec/RequiredRubyVersion:
  Enabled: false

Gemspec/RequireMFA:
  Enabled: false

Lint/HashCompareByIdentity:
  Enabled: true

Lint/RedundantSafeNavigation:
  Enabled: true

Style/ClassEqualityComparison:
  Enabled: true

Lint/ShadowingOuterLocalVariable:
  Enabled: false

Metrics/AbcSize:
  Max: 18

Metrics/MethodLength:
  Max: 20

Rails:
  Enabled: false

Style/ModuleFunction:
  Enabled: false

Style/SignalException:
  Enabled: false

Layout/LineLength:
  Max: 180

Layout/SpaceBeforeFirstArg:
  Enabled: false

RSpec/MultipleMemoizedHelpers:
  Enabled: false

# Short-hand Hash syntax does not work prior 3.1.
# See https://gitlab.com/gitlab-org/gitlab/-/issues/435940#note_1703307479
Style/HashSyntax:
  EnforcedShorthandSyntax: never

# Anonymous block forwarding does not work prior 3.1.
Naming/BlockForwarding:
  Enabled: false
